diff --git a/oflog/include/dcmtk/oflog/spi/logimpl.h b/oflog/include/dcmtk/oflog/spi/logimpl.h
index add4962..b675fc4 100644
--- a/oflog/include/dcmtk/oflog/spi/logimpl.h
+++ b/oflog/include/dcmtk/oflog/spi/logimpl.h
@@ -1,10 +1,11 @@
+// -*- C++ -*-
 // Module:  Log4CPLUS
 // File:    loggerimpl.h
 // Created: 6/2001
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2001-2009 Tad E. Smith
+// Copyright 2001-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -20,16 +21,21 @@
 
 /** @file */
 
-#ifndef DCMTK__LOG4CPLUS_SPI_LOGGER_HEADER_
-#define DCMTK__LOG4CPLUS_SPI_LOGGER_HEADER_
+#ifndef DCMTK_LOG4CPLUS_SPI_LOGGER_HEADER_
+#define DCMTK_LOG4CPLUS_SPI_LOGGER_HEADER_
 
 #include "dcmtk/oflog/config.h"
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
 #include "dcmtk/oflog/tstring.h"
 #include "dcmtk/oflog/helpers/apndimpl.h"
 #include "dcmtk/oflog/helpers/pointer.h"
 #include "dcmtk/oflog/spi/logfact.h"
-//#include <memory>
-//#include <vector>
+#include <memory>
+#include "dcmtk/ofstd/ofvector.h"
 
 
 namespace dcmtk {
@@ -44,11 +50,11 @@ namespace log4cplus {
          * evaluation.
          *
          * See the <a href="../../../../manual.html">user manual</a> for an
-         * introduction on this class.
+         * introduction on this class. 
          */
         class DCMTK_LOG4CPLUS_EXPORT LoggerImpl
-            : public virtual helpers::SharedObject,
-              public helpers::AppenderAttachableImpl
+            : public virtual log4cplus::helpers::SharedObject,
+              public log4cplus::helpers::AppenderAttachableImpl
         {
         public:
             typedef helpers::SharedObjectPtr<LoggerImpl> SharedLoggerImplPtr;
@@ -59,23 +65,23 @@ namespace log4cplus {
              * Call the appenders in the hierrachy starting at
              * <code>this</code>.  If no appenders could be found, emit a
              * warning.
-             *
+             * 
              * This method calls all the appenders inherited from the
              * hierarchy circumventing any evaluation of whether to log or not
              * to log the particular log request.
-             *
-             * @param event The event to log.
+             *                                   
+             * @param event The event to log. 
              */
             virtual void callAppenders(const InternalLoggingEvent& event);
 
             /**
              * Close all attached appenders implementing the AppenderAttachable
-             * interface.
+             * interface.  
              */
             virtual void closeNestedAppenders();
 
             /**
-             * Check whether this logger is enabled for a given LogLevel passed
+             * Check whether this logger is enabled for a given LogLevel passed 
              * as parameter.
              *
              * @return boolean True if this logger is enabled for <code>ll</code>.
@@ -83,25 +89,26 @@ namespace log4cplus {
             virtual bool isEnabledFor(LogLevel ll) const;
 
             /**
-             * This generic form is intended to be used by wrappers.
+             * This generic form is intended to be used by wrappers. 
              */
-            virtual void log(LogLevel ll, const tstring& message,
-                             const char* file=NULL, int line=-1,
-                             const char* function=NULL);
+            virtual void log(LogLevel ll, const log4cplus::tstring& message,
+                             const char* file=NULL, int line=-1);
+
+            virtual void log(spi::InternalLoggingEvent const &);
 
             /**
              * Starting from this logger, search the logger hierarchy for a
              * "set" LogLevel and return it. Otherwise, return the LogLevel of the
              * root logger.
-             *
+             *                     
              * The Logger class is designed so that this method executes as
              * quickly as possible.
              */
             virtual LogLevel getChainedLogLevel() const;
 
             /**
-             * Returns the assigned LogLevel, if any, for this Logger.
-             *
+             * Returns the assigned LogLevel, if any, for this Logger.  
+             *           
              * @return LogLevel - the assigned LogLevel.
              */
             LogLevel getLogLevel() const { return this->ll; }
@@ -118,9 +125,9 @@ namespace log4cplus {
             virtual Hierarchy& getHierarchy() const;
 
             /**
-             * Return the logger name.
+             * Return the logger name.  
              */
-            tstring getName() const { return name; }
+            log4cplus::tstring const & getName() const { return name; }
 
             /**
              * Get the additivity flag for this Logger instance.
@@ -143,27 +150,28 @@ namespace log4cplus {
              * It is intended to be used by sub-classes only. You should not
              * create loggers directly.
              *
-             * @param name The name of the logger.
+             * @param name The name of the logger.  
              * @param h Hierarchy
              */
-            LoggerImpl(const tstring& name, Hierarchy& h);
+            LoggerImpl(const log4cplus::tstring& name, Hierarchy& h);
 
 
           // Methods
             /**
              * This method creates a new logging event and logs the event
-             * without further checks.
+             * without further checks.  
              */
             virtual void forcedLog(LogLevel ll,
-                                   const tstring& message,
-                                   const char* file=NULL,
-                                   int line=-1,
-                                   const char* function=NULL);
+                                   const log4cplus::tstring& message,
+                                   const char* file=NULL, 
+                                   int line=-1);
+
+            virtual void forcedLog(spi::InternalLoggingEvent const & ev);
 
 
           // Data
             /** The name of this logger */
-            tstring name;
+            log4cplus::tstring name;
 
             /**
              * The assigned LogLevel of this logger.
@@ -172,18 +180,18 @@ namespace log4cplus {
 
             /**
              * The parent of this logger. All loggers have at least one
-             * ancestor which is the root logger.
+             * ancestor which is the root logger. 
              */
             SharedLoggerImplPtr parent;
 
-            /**
+            /** 
              * Additivity is set to true by default, that is children inherit
              * the appenders of their ancestors by default. If this variable is
              * set to <code>false</code> then the appenders found in the
              * ancestors of this logger are not used. However, the children
              * of this logger will inherit its appenders, unless the children
              * have their additivity flag set to <code>false</code> too. See
-             * the user manual for more details.
+             * the user manual for more details. 
              */
             bool additive;
 
@@ -197,9 +205,9 @@ namespace log4cplus {
             LoggerImpl& operator=(const LoggerImpl&);
 
           // Friends
-            friend class dcmtk::log4cplus::Logger;
-            friend class dcmtk::log4cplus::DefaultLoggerFactory;
-            friend class dcmtk::log4cplus::Hierarchy;
+            friend class log4cplus::Logger;
+            friend class log4cplus::DefaultLoggerFactory;
+            friend class log4cplus::Hierarchy;
         };
 
         typedef LoggerImpl::SharedLoggerImplPtr SharedLoggerImplPtr;
@@ -208,6 +216,6 @@ namespace log4cplus {
 } // end namespace log4cplus
 } // end namespace dcmtk
 
-#endif // DCMTK__LOG4CPLUS_SPI_LOGGER_HEADER_
+#endif // DCMTK_LOG4CPLUS_SPI_LOGGER_HEADER_
 
 
diff --git a/oflog/include/dcmtk/oflog/spi/objreg.h b/oflog/include/dcmtk/oflog/spi/objreg.h
index c804c7c..9a2db04 100644
--- a/oflog/include/dcmtk/oflog/spi/objreg.h
+++ b/oflog/include/dcmtk/oflog/spi/objreg.h
@@ -1,10 +1,11 @@
+// -*- C++ -*-
 // Module:  Log4CPLUS
 // File:    objectregistry.h
 // Created: 3/2003
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2003-2009 Tad E. Smith
+// Copyright 2003-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -24,13 +25,16 @@
 #define DCMTK_LOG4CPLUS_SPI_OBJECT_REGISTRY_HEADER_
 
 #include "dcmtk/oflog/config.h"
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
 #include "dcmtk/oflog/tstring.h"
-#include "dcmtk/oflog/helpers/threads.h"
-#include "dcmtk/ofstd/oflist.h"
+#include "dcmtk/oflog/thread/syncprim.h"
 #include "dcmtk/ofstd/ofmap.h"
-//#include <map>
-//#include <memory>
-//#include <vector>
+#include <memory>
+#include "dcmtk/ofstd/ofvector.h"
 
 
 namespace dcmtk {
@@ -48,12 +52,12 @@ namespace log4cplus {
              * Tests to see whether or not an object is bound in the
              * registry as <code>name</code>.
              */
-            bool exists(const tstring& name) const;
+            bool exists(const log4cplus::tstring& name) const;
 
             /**
              * Returns the names of all registered objects.
              */
-            OFList<tstring> getAllNames() const;
+            OFVector<log4cplus::tstring> getAllNames() const;
 
         protected:
           // Ctor and Dtor
@@ -65,13 +69,13 @@ namespace log4cplus {
              * Used to enter an object into the registry.  (The registry now
              * owns <code>object</code>.)
              */
-            bool putVal(const tstring& name, void* object);
+            bool putVal(const log4cplus::tstring& name, void* object);
 
             /**
              * Used to retrieve an object from the registry.  (The registry
              * owns the returned pointer.)
              */
-            void* getVal(const tstring& name) const;
+            void* getVal(const log4cplus::tstring& name) const;
 
             /**
              * Deletes <code>object</code>.
@@ -84,11 +88,15 @@ namespace log4cplus {
             virtual void clear();
 
           // Types
-            typedef OFMap<tstring, void*> ObjectMap;
+            typedef OFMap<log4cplus::tstring, void*> ObjectMap;
 
           // Data
-            DCMTK_LOG4CPLUS_MUTEX_PTR_DECLARE mutex;
+            thread::Mutex mutex;
             ObjectMap data;
+
+        private:
+            ObjectRegistryBase (ObjectRegistryBase const &);
+            ObjectRegistryBase & operator = (ObjectRegistryBase const &);
         };
 
     }
diff --git a/oflog/include/dcmtk/oflog/spi/rootlog.h b/oflog/include/dcmtk/oflog/spi/rootlog.h
index d6dd12e..64e3aa5 100644
--- a/oflog/include/dcmtk/oflog/spi/rootlog.h
+++ b/oflog/include/dcmtk/oflog/spi/rootlog.h
@@ -1,10 +1,11 @@
+// -*- C++ -*-
 // Module:  Log4CPLUS
 // File:    rootlogger.h
 // Created: 6/2001
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2001-2009 Tad E. Smith
+// Copyright 2001-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -20,11 +21,15 @@
 
 /** @file */
 
-#ifndef DCMTK__LOG4CPLUS_SPI_ROOT_LOGGER_HEADER_
-#define DCMTK__LOG4CPLUS_SPI_ROOT_LOGGER_HEADER_
+#ifndef DCMTK_LOG4CPLUS_SPI_ROOT_LOGGER_HEADER_
+#define DCMTK_LOG4CPLUS_SPI_ROOT_LOGGER_HEADER_
 
 #include "dcmtk/oflog/config.h"
-#include "dcmtk/oflog/helpers/loglog.h"
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
 #include "dcmtk/oflog/spi/logimpl.h"
 
 namespace dcmtk {
@@ -45,7 +50,7 @@ namespace log4cplus {
           // Ctors
             /**
              * The root logger names itself as "root". However, the root
-             * logger cannot be retrieved by name.
+             * logger cannot be retrieved by name.  
              */
             RootLogger(Hierarchy& h, LogLevel ll);
 
@@ -57,7 +62,7 @@ namespace log4cplus {
             virtual LogLevel getChainedLogLevel() const;
 
             /**
-             * Setting a NOT_SET_LOG_LEVEL value to the LogLevel of the root logger
+             * Setting a NOT_SET_LOG_LEVEL value to the LogLevel of the root logger 
              * may have catastrophic results. We prevent this here.
              */
             void setLogLevel(LogLevel ll);
@@ -68,5 +73,5 @@ namespace log4cplus {
 } // end namespace log4cplus
 } // end namespace dcmtk
 
-#endif // DCMTK__LOG4CPLUS_SPI_ROOT_LOGGER_HEADER_
+#endif // DCMTK_LOG4CPLUS_SPI_ROOT_LOGGER_HEADER_
 
diff --git a/oflog/include/dcmtk/oflog/streams.h b/oflog/include/dcmtk/oflog/streams.h
index a8a486c..4f6c5fb 100644
--- a/oflog/include/dcmtk/oflog/streams.h
+++ b/oflog/include/dcmtk/oflog/streams.h
@@ -1,10 +1,11 @@
+// -*- C++ -*-
 // Module:  Log4CPLUS
 // File:    streams.h
 // Created: 4/2003
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2003-2009 Tad E. Smith
+// Copyright 2003-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -24,18 +25,35 @@
 #define DCMTK_LOG4CPLUS_STREAMS_HEADER_
 
 #include "dcmtk/oflog/config.h"
-#include "dcmtk/oflog/tstring.h"
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
+#include "dcmtk/oflog/tchar.h"
 #include "dcmtk/ofstd/ofstream.h"
 
-#define DCMTK_LOG4CPLUS_STREAM_NAMESPACE std
+#include <iosfwd>
+
 
-namespace dcmtk {
-namespace log4cplus {
-    typedef STD_NAMESPACE ostream tostream;
-    typedef STD_NAMESPACE istream tistream;
-    typedef OFOStringStream        tostringstream;
+namespace dcmtk
+{
+namespace log4cplus
+{
+    typedef STD_NAMESPACE basic_ostream<tchar> tostream;
+    typedef STD_NAMESPACE basic_istream<tchar> tistream;
+    typedef OFOStringStream tostringstream;
+    typedef OFIStringStream tistringstream;
+    extern DCMTK_LOG4CPLUS_EXPORT tostream & tcout;
+    extern DCMTK_LOG4CPLUS_EXPORT tostream & tcerr;
 }
 }
 
+#if defined (UNICODE) && defined (DCMTK_LOG4CPLUS_ENABLE_GLOBAL_C_STRING_STREAM_INSERTER)
+
+DCMTK_LOG4CPLUS_EXPORT log4cplus::tostream& operator <<(log4cplus::tostream&, const char* psz );
+
+#endif
+
 #endif // DCMTK_LOG4CPLUS_STREAMS_HEADER_
 
diff --git a/oflog/include/dcmtk/oflog/syslogap.h b/oflog/include/dcmtk/oflog/syslogap.h
index 6788c92..847abc0 100644
--- a/oflog/include/dcmtk/oflog/syslogap.h
+++ b/oflog/include/dcmtk/oflog/syslogap.h
@@ -1,10 +1,11 @@
+// -*- C++ -*-
 // Module:  Log4CPLUS
-// File:    syslogappender.h
+// File:    syslogap.h
 // Created: 6/2001
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2001-2009 Tad E. Smith
+// Copyright 2001-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -20,16 +21,23 @@
 
 /** @file */
 
-#ifndef DCMTK__LOG4CPLUS_SYSLOG_APPENDER_HEADER_
-#define DCMTK__LOG4CPLUS_SYSLOG_APPENDER_HEADER_
+#ifndef DCMTK_LOG4CPLUS_SYSLOG_APPENDER_HEADER_
+#define DCMTK_LOG4CPLUS_SYSLOG_APPENDER_HEADER_
 
 #include "dcmtk/oflog/config.h"
 
-#if defined(DCMTK_LOG4CPLUS_HAVE_SYSLOG_H) && !defined(_WIN32)
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
 #include "dcmtk/oflog/appender.h"
+#include "dcmtk/oflog/helpers/socket.h"
+
 
-namespace dcmtk {
-namespace log4cplus {
+namespace dcmtk
+{
+namespace log4cplus
+{
 
     /**
      * Appends log events to a file.
@@ -39,13 +47,35 @@ namespace log4cplus {
      * <dt><tt>ident</tt></dt>
      * <dd>First argument to <code>openlog()</code>, a string that
      * will be prepended to every message.</dd>
+     *
+     * <dt><tt>facility</tt></dt>
+     * <dd>Facility is used in combination with syslog level in first
+     * argument to syslog(). It can be one of the supported facility
+     * names (case insensitive), e.g. auth, cron, kern, mail, news
+     * etc.</dd>
+     *
+     * <dt><tt>host</tt></dt>
+     * <dd>Destination syslog host. When this property is specified,
+     * messages are sent using UDP to destination host, otherwise
+     * messages are logged to local syslog.</dd>
+     *
+     * <dt><tt>port</tt></dt>
+     * <dd>Destination port of syslog service on host specified by the
+     * <tt>host</tt> property. The default value is port 514.</dd>
      * </dl>
+     *
+     * \note Messages sent to remote syslog using UDP are conforming
+     * to RFC5424.
      */
     class DCMTK_LOG4CPLUS_EXPORT SysLogAppender : public Appender {
     public:
       // Ctors
+#if defined (DCMTK_LOG4CPLUS_HAVE_SYSLOG_H)
         SysLogAppender(const tstring& ident);
-        SysLogAppender(const helpers::Properties properties, tstring& error);
+#endif
+        SysLogAppender(const tstring& ident, const tstring & host,
+            int port = 514, const tstring & facility = tstring ());
+        SysLogAppender(const log4cplus::helpers::Properties & properties);
 
       // Dtor
         virtual ~SysLogAppender();
@@ -56,20 +86,36 @@ namespace log4cplus {
     protected:
         virtual int getSysLogLevel(const LogLevel& ll) const;
         virtual void append(const spi::InternalLoggingEvent& event);
+#if defined (DCMTK_LOG4CPLUS_HAVE_SYSLOG_H)
+        void appendLocal(const spi::InternalLoggingEvent& event);
+#endif
+        void appendRemote(const spi::InternalLoggingEvent& event);
 
       // Data
         tstring ident;
+        int facility;
+
+        typedef void (SysLogAppender:: * AppendFuncType) (
+            const spi::InternalLoggingEvent&);
+        AppendFuncType appendFunc;
+
+        tstring host;
+        int port;
+        helpers::Socket syslogSocket;
+
+        static tstring const remoteTimeFormat;
 
     private:
       // Disallow copying of instances of this class
         SysLogAppender(const SysLogAppender&);
         SysLogAppender& operator=(const SysLogAppender&);
+
+        tstring identStr;
+        tstring hostname;
     };
 
 } // end namespace log4cplus
 } // end namespace dcmtk
 
-#endif // defined(HAVE_SYSLOG_H)
-
-#endif // DCMTK__LOG4CPLUS_SYSLOG_APPENDER_HEADER_
 
+#endif // DCMTK_LOG4CPLUS_SYSLOG_APPENDER_HEADER_
diff --git a/oflog/include/dcmtk/oflog/tchar.h b/oflog/include/dcmtk/oflog/tchar.h
new file mode 100644
index 0000000..c3655d0
--- /dev/null
+++ b/oflog/include/dcmtk/oflog/tchar.h
@@ -0,0 +1,66 @@
+// -*- C++ -*-
+//  Copyright (C) 2010, Vaclav Haisman. All rights reserved.
+//  
+//  Redistribution and use in source and binary forms, with or without modifica-
+//  tion, are permitted provided that the following conditions are met:
+//  
+//  1. Redistributions of  source code must  retain the above copyright  notice,
+//     this list of conditions and the following disclaimer.
+//  
+//  2. Redistributions in binary form must reproduce the above copyright notice,
+//     this list of conditions and the following disclaimer in the documentation
+//     and/or other materials provided with the distribution.
+//  
+//  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
+//  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
+//  FITNESS  FOR A PARTICULAR  PURPOSE ARE  DISCLAIMED.  IN NO  EVENT SHALL  THE
+//  APACHE SOFTWARE  FOUNDATION  OR ITS CONTRIBUTORS  BE LIABLE FOR  ANY DIRECT,
+//  INDIRECT, INCIDENTAL, SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL  DAMAGES (INCLU-
+//  DING, BUT NOT LIMITED TO, PROCUREMENT  OF SUBSTITUTE GOODS OR SERVICES; LOSS
+//  OF USE, DATA, OR  PROFITS; OR BUSINESS  INTERRUPTION)  HOWEVER CAUSED AND ON
+//  ANY  THEORY OF LIABILITY,  WHETHER  IN CONTRACT,  STRICT LIABILITY,  OR TORT
+//  (INCLUDING  NEGLIGENCE OR  OTHERWISE) ARISING IN  ANY WAY OUT OF THE  USE OF
+//  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+/** @file */
+
+#ifndef DCMTK_LOG4CPLUS_TCHAR_HEADER_
+#define DCMTK_LOG4CPLUS_TCHAR_HEADER_
+
+#include "dcmtk/oflog/config.h"
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
+#if defined (_WIN32)
+#include <cstddef>
+#endif
+
+
+#ifdef UNICODE
+#  define DCMTK_LOG4CPLUS_TEXT2(STRING) L##STRING
+#else
+#  define DCMTK_LOG4CPLUS_TEXT2(STRING) STRING
+#endif // UNICODE
+#define DCMTK_LOG4CPLUS_TEXT(STRING) DCMTK_LOG4CPLUS_TEXT2(STRING)
+
+
+namespace dcmtk
+{
+namespace log4cplus
+{
+
+#if defined (UNICODE)
+typedef wchar_t tchar;
+
+#else
+typedef char tchar;
+
+#endif
+
+} // namespace log4cplus
+} // end namespace dcmtk
+
+
+#endif // DCMTK_LOG4CPLUS_TCHAR_HEADER_
diff --git a/oflog/include/dcmtk/oflog/thread/impl/syncimpl.h b/oflog/include/dcmtk/oflog/thread/impl/syncimpl.h
new file mode 100644
index 0000000..c6ff62b
--- /dev/null
+++ b/oflog/include/dcmtk/oflog/thread/impl/syncimpl.h
@@ -0,0 +1,241 @@
+// -*- C++ -*-
+//  Copyright (C) 2009-2010, Vaclav Haisman. All rights reserved.
+//  
+//  Redistribution and use in source and binary forms, with or without modifica-
+//  tion, are permitted provided that the following conditions are met:
+//  
+//  1. Redistributions of  source code must  retain the above copyright  notice,
+//     this list of conditions and the following disclaimer.
+//  
+//  2. Redistributions in binary form must reproduce the above copyright notice,
+//     this list of conditions and the following disclaimer in the documentation
+//     and/or other materials provided with the distribution.
+//  
+//  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
+//  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
+//  FITNESS  FOR A PARTICULAR  PURPOSE ARE  DISCLAIMED.  IN NO  EVENT SHALL  THE
+//  APACHE SOFTWARE  FOUNDATION  OR ITS CONTRIBUTORS  BE LIABLE FOR  ANY DIRECT,
+//  INDIRECT, INCIDENTAL, SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL  DAMAGES (INCLU-
+//  DING, BUT NOT LIMITED TO, PROCUREMENT  OF SUBSTITUTE GOODS OR SERVICES; LOSS
+//  OF USE, DATA, OR  PROFITS; OR BUSINESS  INTERRUPTION)  HOWEVER CAUSED AND ON
+//  ANY  THEORY OF LIABILITY,  WHETHER  IN CONTRACT,  STRICT LIABILITY,  OR TORT
+//  (INCLUDING  NEGLIGENCE OR  OTHERWISE) ARISING IN  ANY WAY OUT OF THE  USE OF
+//  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+#ifndef DCMTK_LOG4CPLUS_THREAD_SYNCPRIMS_IMPL_H
+#define DCMTK_LOG4CPLUS_THREAD_SYNCPRIMS_IMPL_H
+
+#include "dcmtk/oflog/config.h"
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
+#if ! defined (DCMTK_INSIDE_LOG4CPLUS)
+#  error "This header must not be be used outside log4cplus' implementation files."
+#endif
+
+#include <stdexcept>
+#include "dcmtk/oflog/thread/syncprim.h"
+#if defined (_WIN32)
+#  include "dcmtk/oflog/config/windowsh.h"
+
+#elif defined (DCMTK_LOG4CPLUS_USE_PTHREADS)
+#  include <errno.h>
+#  include <pthread.h>
+#  include <semaphore.h>
+#  if defined (DCMTK_LOG4CPLUS_USE_NAMED_POSIX_SEMAPHORE)
+#    include <sstream>
+#    include <string>
+#    if defined (DCMTK_LOG4CPLUS_HAVE_SYS_TYPES_H)
+#      include <sys/types.h>
+#    endif
+#    if defined (DCMTK_LOG4CPLUS_HAVE_UNISTD_H)
+#      include <unistd.h>
+#    endif
+#  endif
+#  if defined (DCMTK_LOG4CPLUS_HAVE_FCNTL_H)
+#    include <fcntl.h>
+#  endif
+#  include "dcmtk/oflog/helpers/timehelp.h"
+
+#endif
+
+
+namespace dcmtk {
+namespace log4cplus { namespace thread { namespace impl {
+
+
+DCMTK_LOG4CPLUS_EXPORT void syncprims_throw_exception (char const * const msg,
+    char const * const file, int line) DCMTK_LOG4CPLUS_ATTRIBUTE_NORETURN;
+
+
+#define DCMTK_LOG4CPLUS_THROW_RTE(msg) \
+    do { syncprims_throw_exception (msg, __FILE__, __LINE__); } while (0)
+
+
+class ManualResetEvent;
+
+
+class Mutex
+    : public MutexImplBase
+{
+public:
+    explicit Mutex (log4cplus::thread::Mutex::Type);
+    ~Mutex ();
+
+    void lock () const;
+    void unlock () const;
+
+private:
+#if defined (DCMTK_LOG4CPLUS_USE_PTHREADS)
+    mutable pthread_mutex_t mtx;
+    friend class ManualResetEvent;
+#elif defined (DCMTK_LOG4CPLUS_USE_WIN32_THREADS)
+    mutable CRITICAL_SECTION cs;
+#endif
+    
+    Mutex (Mutex const &);
+    Mutex & operator = (Mutex &);
+};
+
+
+typedef SyncGuard<Mutex> MutexGuard;
+
+
+class Semaphore
+    : public SemaphoreImplBase
+{
+public:
+    Semaphore (unsigned max, unsigned initial);
+    ~Semaphore ();
+
+    void lock () const;
+    void unlock () const;
+
+private:
+#if defined (DCMTK_LOG4CPLUS_USE_PTHREADS)
+#  if defined (DCMTK_LOG4CPLUS_USE_NAMED_POSIX_SEMAPHORE)
+    sem_t * sem;
+#  else
+    mutable sem_t sem;
+#  endif
+#elif defined (DCMTK_LOG4CPLUS_USE_WIN32_THREADS)
+    HANDLE sem;
+#endif
+
+    Semaphore (Semaphore const &);
+    Semaphore & operator = (Semaphore const &);
+};
+
+
+typedef SyncGuard<Semaphore> SemaphoreGuard;
+
+
+class FairMutex
+    : public FairMutexImplBase
+{
+public:
+    FairMutex ();
+    ~FairMutex ();
+
+    void lock () const;
+    void unlock () const;
+
+private:
+#if defined (DCMTK_LOG4CPLUS_USE_PTHREADS)
+    Semaphore sem;
+#elif defined (DCMTK_LOG4CPLUS_USE_WIN32_THREADS)
+    HANDLE mtx;
+#endif
+
+    FairMutex (FairMutex const &);
+    FairMutex & operator = (FairMutex &);
+};
+
+
+typedef SyncGuard<FairMutex> FairMutexGuard;
+
+
+class ManualResetEvent
+    : public ManualResetEventImplBase
+{
+public:
+    ManualResetEvent (bool = false);
+    ~ManualResetEvent ();
+
+    void signal () const;
+    void wait () const;
+    bool timed_wait (unsigned long msec) const;
+    void reset () const;
+
+private:
+#if defined (DCMTK_LOG4CPLUS_USE_PTHREADS)
+    mutable pthread_cond_t cv;
+    mutable Mutex mtx;
+    mutable volatile unsigned sigcount;
+    mutable volatile bool signaled;
+#elif defined (DCMTK_LOG4CPLUS_USE_WIN32_THREADS)
+    HANDLE ev;
+#endif
+
+    ManualResetEvent (ManualResetEvent const &);
+    ManualResetEvent & operator = (ManualResetEvent const &);
+};
+
+
+class SharedMutex
+    : public SharedMutexImplBase
+{
+public:
+    SharedMutex ();
+    ~SharedMutex ();
+
+    void rdlock () const;
+    void wrlock () const;
+    void rdunlock () const;
+    void wrunlock () const;
+
+private:
+#if defined (DCMTK_LOG4CPLUS_POOR_MANS_SHAREDMUTEX)
+    Mutex m1;
+    Mutex m2;
+    Mutex m3;
+    Semaphore w;
+    mutable unsigned writer_count;
+    Semaphore r;
+    mutable unsigned reader_count;
+
+#elif defined (DCMTK_LOG4CPLUS_USE_PTHREADS)
+    void unlock () const;
+
+    mutable pthread_rwlock_t rwl;
+
+#elif defined (DCMTK_LOG4CPLUS_USE_SRW_LOCK)
+    mutable SRWLOCK srwl;
+
+#endif
+
+    SharedMutex (SharedMutex const &);
+    SharedMutex & operator = (SharedMutex const &);
+};
+
+
+} } } // namespace log4cplus { namespace thread { namespace impl {
+} // end namespace dcmtk
+
+
+// Include the appropriate implementations of the classes declared
+// above.
+
+#if defined (DCMTK_LOG4CPLUS_USE_PTHREADS)
+#  include "dcmtk/oflog/thread/impl/syncpthr.h"
+#elif defined (DCMTK_LOG4CPLUS_USE_WIN32_THREADS)
+#  include "dcmtk/oflog/thread/impl/syncwin.h"
+#endif
+
+
+#undef DCMTK_LOG4CPLUS_THROW_RTE
+
+
+#endif // DCMTK_LOG4CPLUS_THREAD_SYNCPRIMS_IMPL_H
diff --git a/oflog/include/dcmtk/oflog/thread/impl/syncpmsm.h b/oflog/include/dcmtk/oflog/thread/impl/syncpmsm.h
new file mode 100644
index 0000000..1d5d176
--- /dev/null
+++ b/oflog/include/dcmtk/oflog/thread/impl/syncpmsm.h
@@ -0,0 +1,119 @@
+// -*- C++ -*-
+//  Copyright (C) 2010, Vaclav Haisman. All rights reserved.
+//  
+//  Redistribution and use in source and binary forms, with or without modifica-
+//  tion, are permitted provided that the following conditions are met:
+//  
+//  1. Redistributions of  source code must  retain the above copyright  notice,
+//     this list of conditions and the following disclaimer.
+//  
+//  2. Redistributions in binary form must reproduce the above copyright notice,
+//     this list of conditions and the following disclaimer in the documentation
+//     and/or other materials provided with the distribution.
+//  
+//  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
+//  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
+//  FITNESS  FOR A PARTICULAR  PURPOSE ARE  DISCLAIMED.  IN NO  EVENT SHALL  THE
+//  APACHE SOFTWARE  FOUNDATION  OR ITS CONTRIBUTORS  BE LIABLE FOR  ANY DIRECT,
+//  INDIRECT, INCIDENTAL, SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL  DAMAGES (INCLU-
+//  DING, BUT NOT LIMITED TO, PROCUREMENT  OF SUBSTITUTE GOODS OR SERVICES; LOSS
+//  OF USE, DATA, OR  PROFITS; OR BUSINESS  INTERRUPTION)  HOWEVER CAUSED AND ON
+//  ANY  THEORY OF LIABILITY,  WHETHER  IN CONTRACT,  STRICT LIABILITY,  OR TORT
+//  (INCLUDING  NEGLIGENCE OR  OTHERWISE) ARISING IN  ANY WAY OUT OF THE  USE OF
+//  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+//! @file
+//! This file contains implementations of reader-writer locking
+//! primitive using other primitives, IOW poor man's rwlock.
+//! It does not contain any include guards because it is only a fragment
+//! to be included by syncprims-{pthreads,win32}.h.
+
+
+#if ! defined (DCMTK_INSIDE_LOG4CPLUS)
+#  error "This header must not be be used outside log4cplus' implementation files."
+#endif
+
+
+// This implements algorithm described in "Concurrent Control with "Readers"
+// and "Writers"; P.J. Courtois, F. Heymans, and D.L. Parnas;
+// MBLE Research Laboratory; Brussels, Belgium"
+
+
+inline
+SharedMutex::SharedMutex ()
+    : m1 (log4cplus::thread::Mutex::DEFAULT)
+    , m2 (log4cplus::thread::Mutex::DEFAULT)
+    , m3 (log4cplus::thread::Mutex::DEFAULT)
+    , w (1, 1)
+    , writer_count (0)
+    , r (1, 1)
+    , reader_count (0)
+{ }
+
+
+inline
+SharedMutex::~SharedMutex ()
+{ }
+
+
+inline
+void
+SharedMutex::rdlock () const
+{
+    MutexGuard m3_guard (m3);
+    SemaphoreGuard r_guard (r);
+    MutexGuard m1_guard (m1);
+    if (reader_count + 1 == 1)
+        w.lock ();
+
+    reader_count += 1;
+}
+
+
+inline
+void
+SharedMutex::rdunlock () const
+{
+    MutexGuard m1_guard (m1);
+    if (reader_count - 1 == 0)
+        w.unlock ();
+
+    reader_count -= 1;
+}
+
+
+inline
+void
+SharedMutex::wrlock () const
+{
+    {
+        MutexGuard m2_guard (m2);
+        if (writer_count + 1 == 1)
+            r.lock ();
+
+        writer_count += 1;
+    }
+    try
+    {
+        w.lock ();
+    }
+    catch (...)
+    {
+        MutexGuard m2_guard (m2);
+        writer_count -= 1;
+        throw;
+    }
+}
+
+
+inline
+void
+SharedMutex::wrunlock () const
+{
+    w.unlock ();
+    MutexGuard m2_guard (m2);
+    if (writer_count - 1 == 0)
+        r.unlock ();
+
+    writer_count -= 1;
+}
